<template>
  <div class="mt-10">
    <v-btn
      v-if="(currentStep - 1) >= minStep"
      @click="previous">
      <v-icon left>arrow_back</v-icon>
      Wstecz
    </v-btn>

    <v-btn
      v-if="(currentStep + 1) <= totalSteps"
      @click="next"
      color="primary">
      Dalej
      <v-icon right>arrow_forward</v-icon>
    </v-btn>

    <v-btn
      v-if="currentStep === totalSteps"
      :href="pdfData"
      color="primary"
      download="wypowiedzenie">
      <v-icon left>cloud_download</v-icon>
      Pobierz PDF
    </v-btn>

    <v-btn
      @click="reset"
      class="ml-5"
      color="">
      <v-icon left color="error">clear</v-icon>
      Resetuj
    </v-btn>
  </div>
</template>

<script>
import { mapGetters, mapActions } from 'vuex';

export default {
  inject: ['parentValidator'],
  computed: {
    ...mapGetters('form', {
      currentStep: 'getCurrentStep',
      minStep: 'getMinStep',
      totalSteps: 'getTotalSteps',
    }),
    ...mapGetters('pdf', { pdfData: 'getPdfData' }),
  },
  methods: {
    previous() {
      this.setCurrentStep(this.currentStep - 1);
    },
    async next() {
      // wait for validation state
      const isFormValid = await this.$validator.validateAll();

      // if form for current step is valid and there is another step, switch to it
      if (isFormValid) {
        this.setCurrentStep(this.currentStep + 1);
      }
    },
    reset() {
      this.resetStore();
      this.$validator.reset();
    },
    ...mapActions('form', ['setCurrentStep']),
    ...mapActions(['resetStore']),
  },
  created() {
    this.$validator = this.parentValidator;
  },
};
</script>
